.386
.model flat,stdcall
option casemap:none

include \masm32\include\windows.inc
include \masm32\include\user32.inc
include \masm32\include\kernel32.inc
include \masm32\include\shell32.inc
include \masm32\include\comctl32.inc
include \masm32\include\gdi32.inc
include \masm32\include\msimg32.inc

includelib \masm32\lib\user32.lib
includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\shell32.lib
includelib \masm32\lib\comctl32.lib
includelib \masm32\lib\gdi32.lib
includelib \masm32\lib\msimg32.lib

include \masm32\macros\macros.asm

WinMain			PROTO :DWORD,:DWORD,:DWORD,:DWORD
WndProc			PROTO :DWORD,:DWORD,:DWORD,:DWORD
NewStar         PROTO :DWORD 
Random          PROTO :DWORD
; ################################# required for Text Scroll !!!
; Macros
m2m MACRO M1, M2
	push M2
	pop  M1
ENDM


GETV MACRO dVar
	mov eax,dVar 
  EXITM <eax>
ENDM
; ################################# required for Text Scroll !!!

.const
IDI_ICON    equ 200
IDD_DLG1    equ 101
NumberOfStars equ 1000 ; No. Stars
StarStructureSize equ 28 ;Size Struct Star
SpeedMin equ 1 ; Low Speed or speedmin
SpeedMax equ 10 ;Max speed or speedmax

; ################################# required for Text Scroll !!!
TIMER1          equ 1
IDT_STARS		equ 10
IDT_TEXT		equ 60
TEXTFONT		equ "Acknowledge -BRK-" ; you could have whatever font here! For Example "Viner Hand ITC" any fonts that are avialable in Microsoft Office Word!!!
COLORTEXT		equ 00FFFFFFh ; Text coulor
SCROLLSPEED		equ 35 ; Scroll Speed -> a lesser Number = Faster!
FONTZ			equ 400
; ################################# required for Text Scroll !!!
.data
ClassName			db 'DLGCLASS',0
DlgName				db 'MyDialog',0
AppName				db 'starfield window',0

; ################################# required for Text Scroll !!!
;----------------------------------------------------------------------------
szWindowMsg db 'page up increase speed ,page down decreases speed :) ',0Dh,0Ah
            db 0Dh,0Ah
            db 'Welcome to MASM32, state of the art ',0Dh,0Ah
            db 0Dh,0Ah ; puts a space ! 
            db 'Windows assembler programming.',0Dh,0Ah
            db 0Dh,0Ah 
            db 'are all part of writing assembler.',0Dh,0Ah
            db 0Dh,0Ah 
            db 'structures, pointers, data sizes etc... ',0Dh,0Ah,0  
;----------------------------------------------------------------------------
DELAY_VALUE	  equ	10
ScrollOffset  DWORD	1
; ################################# required for Text Scroll !!!  

EasternStar db FALSE ;Eastern Star Nv
Speed dd 2 ;speed
DisplaysTrolling db TRUE ;Drive type displayed or Displays Trolling
.data?
hIcon     HICON     ?
hInstance HINSTANCE ?
; 
CommandLine			dd ?
hDlg				dd ?
; 
Xwindow dd ? ;window
Ywindow dd ?
Xwindowdiv2 dd ?
Ywindowdiv2 dd ?
hStars HANDLE ? ;H Stars
pStars dd ? ;P Stars
hArrPlan dd ?
RandomNamePr dd ? ;Random Name Pr
rect RECT  <?>

WindowRect      RECT     <?>
MyRect          RECT     <?>
rClientWindow   RECT     <?>
hDialog       HWND ?
; ################################# required for Text Scroll !!!   
hmainDC         HDC       ?
hLayerDC1		HDC		  ?
hLayerDC2		HDC		  ?
hmainbmp        HBITMAP   ?

brush		dd	?
hBgColor     	HBRUSH	?
hFontWindow	HFONT		?
rScroll		    RECT   <?>
PosRct		RECT	   <?>
hbmp		HANDLE		?
chdc		HDC		    ?
TimerID		DWORD		?
black dd ?

PictureW       dd ?
PictureH       dd ?
; ################################# required for Text Scroll !!!   
.code


start:
   
   
mov hInstance,rv(GetModuleHandle,0)
INVOKE InitCommonControls  
INVOKE LoadIcon, eax, IDI_ICON 
mov hIcon, eax
; ---------------------------------------------
;   Call the dialog box stored in resource file
; ---------------------------------------------
INVOKE DialogBoxParam, hInstance, IDD_DLG1 , NULL, ADDR WndProc, 0
INVOKE ExitProcess, 0

WndProc proc uses ebx hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

LOCAL hdc:HANDLE
LOCAL hMemDC:HANDLE
LOCAL hBmp:HANDLE
LOCAL ps:PAINTSTRUCT

	.IF uMsg ==WM_INITDIALOG
	INVOKE SetWindowText, hWnd, addr AppName	
	INVOKE SendMessage, hWnd, WM_SETICON,ICON_SMALL, hIcon



invoke GlobalAlloc, GMEM_MOVEABLE or GMEM_ZEROINIT, NumberOfStars * StarStructureSize
mov hStars, eax
invoke GlobalLock, hStars
mov pStars, eax
; ################################# required for Text Scroll !!!    
; ################################# creats font size so letters are not to big	
;NOTE: you could chance "FW_NORMAL" with "FW_BOLD" ...See CreateFont API for more options!
	mov hFontWindow,FUNC(CreateFont,15, 0, 0, 0, FW_NORMAL, 0, 0, 0, 0, 0, 0, 0, 0, SADD(TEXTFONT)) ; first number is the font size!!
; ################################# creats font size so letters are not to big	

; ################################# required for Text Scroll !!!          
 ; ################################# highlights the text (creats colour to match background colour)		
invoke SetTextColor,chdc,COLORTEXT ;colour the text

invoke SetBkMode,chdc,TRANSPARENT ;make text background transparent

; ################################# highlights the text (creats colour to match background colour)
; ################################# required for Text Scroll !!!  
  
; ################################# required for Text Scroll !!!    
       INVOKE  GetClientRect,hWnd,ADDR rect
         m2m PictureW,rect.right
         m2m PictureH,rect.bottom

      mov black,rv(CreateSolidBrush,black)
 		invoke CreateSolidBrush,TRANSPARENT 
	mov hBgColor,eax


; ################################# required for Text Scroll !!!  

	invoke GetClientRect,hWnd,ADDR WindowRect
	mov hdc,FUNC(GetDC,hWnd) ; mov chdc,FUNC(GetDC,hWnd)
	mov chdc,FUNC(CreateCompatibleDC,hdc); creats window
	mov hmainDC,FUNC(CreateCompatibleBitmap,hdc,WindowRect.right,WindowRect.bottom); creats window
	invoke SelectObject,chdc,hbmp

	;/* layer for drawing stars */
	mov hLayerDC2,rv(CreateCompatibleDC,hdc)
	invoke DeleteObject,rv(SelectObject,hLayerDC2,rv(CreateCompatibleBitmap,hdc,WindowRect.right,WindowRect.bottom))
	
	;/* layer for draing text */
	mov hLayerDC1,rv(CreateCompatibleDC,hdc)
	invoke DeleteObject,rv(SelectObject,hLayerDC1,rv(CreateCompatibleBitmap,hdc,WindowRect.right,WindowRect.bottom))
	;/* selct black brsuh -> this becomes the 'tansparent color' */
	invoke DeleteObject,rv(SelectObject,hLayerDC1,rv(GetStockObject,BLACK_BRUSH))
	invoke SetBkColor,hLayerDC1,0
	;/* white text */
	invoke SetTextColor,hLayerDC1,00FFFFFFh
	invoke DeleteObject,rv(SelectObject,hLayerDC1,hFontWindow)
	;/*                                                                                   */
	;/* normaly the layer/buffer DC must filled/drawn here to make shure ther is somethin */
	;/* usful in it.                                                                      */

	
	mov rClientWindow.top,1
	mov rClientWindow.left,1
	m2m rClientWindow.right,WindowRect.right
	m2m rClientWindow.bottom,WindowRect.bottom    
	dec rClientWindow.bottom
	dec rClientWindow.right
	invoke FillRect,hLayerDC2,ADDR WindowRect,hBgColor ; color for about window

; ################################# required for Text Scroll !!!  


; ################################# required for Text Scroll !!!   
 	invoke IntersectClipRect,chdc,rClientWindow.left,rClientWindow.top,rClientWindow.right,rClientWindow.bottom
	
		invoke SelectObject,hdc,hFontWindow	  		
		invoke DrawText,hdc,ADDR szWindowMsg,-1,ADDR rScroll,DT_CALCRECT + DT_NOPREFIX + DT_LEFT + DT_TOP + DT_NOCLIP
	
	m2m rScroll.right,rClientWindow.right
	sub rScroll.right,5
	add rScroll.top,GETV(rClientWindow.bottom)
	add rScroll.bottom,eax	
			
		invoke ReleaseDC,hWnd,hdc	
			
	
	invoke SetTimer,hWnd,IDT_STARS,0,0
    invoke SetTimer,hWnd,IDT_TEXT,SCROLLSPEED,0
      
      invoke GetDC, hWnd
      mov hdc, eax
      
      mov esi,PictureW
      mov edi,PictureH

      invoke CreateCompatibleDC, hdc
      mov hmainDC,eax
      
      invoke CreateCompatibleBitmap, hdc, esi, edi
      mov hmainbmp,eax

      invoke SelectObject, [hmainDC], eax
      
      invoke ReleaseDC,hWnd, hdc
 .ELSEIF uMsg == WM_DESTROY
 
invoke GlobalUnlock, pStars
invoke GlobalFree, hStars
; ################################# required for Text Scroll !!!   
    mov rScroll.top,0
	mov rScroll.bottom,0
	mov rScroll.left,0
	mov rScroll.right,0
	invoke DeleteDC,chdc 
	invoke DeleteObject,hbmp
	invoke KillTimer,hWnd,TimerID
; ################################# required for Text Scroll !!!   
invoke PostQuitMessage, NULL
.ELSEIF uMsg == WM_KEYDOWN
.IF wParam == VK_ESCAPE
invoke SendMessage, hWnd, WM_DESTROY, NULL, NULL
.ELSEIF wParam == VK_PGDN
.IF Speed != SpeedMin
dec Speed
.ENDIF
.ELSEIF wParam == VK_PGUP
.IF Speed != SpeedMax
inc Speed
.ENDIF
        .ELSEIF wParam == VK_T
          .IF DisplaysTrolling
            mov DisplaysTrolling, FALSE
          .ELSE
            mov DisplaysTrolling, TRUE
          .ENDIF
        .ENDIF
        
.ELSEIF uMsg == WM_TIMER
   		
   		invoke GetClientRect,hWnd,ADDR rect
		m2m Xwindow,rect.right
m2m Ywindow,rect.bottom

 mov eax,Xwindow
 shr eax, 1 ; This gets the center point of screen to start starfield
mov Xwindowdiv2, eax
      mov eax,Ywindow
      shr eax, 1 ; This gets the center point of screen to start starfield
mov Ywindowdiv2, eax   
		.if wParam == IDT_STARS
    ;  INVOKE  GetClientRect,hWnd,ADDR rect
 
        invoke BeginPaint, hWnd, ADDR ps
        mov hdc, eax
        invoke CreateCompatibleDC, hdc
        mov hMemDC, eax
        invoke CreateCompatibleBitmap, hdc, Xwindow, Ywindow
        mov hBmp, eax
        invoke SelectObject, hMemDC, hBmp
        invoke FillRect, hMemDC, OFFSET rect, hArrPlan

		        xor ecx, ecx
        .WHILE ecx != NumberOfStars ;NbEtoile=No. Stars
          mov eax, StarStructureSize ;StarStructureSize=Size Struct Star
          mul ecx
          add eax, pStars
          mov ebx, eax
          ;----------------------------------------------;
          ;--- CHECK IF THE STAR IS ALWAYS GOOD ---;
          mov eax, Speed
          .IF dword ptr [ebx + 8] <= eax
            push ecx
            invoke NewStar, ebx  ;NewStar=New Star
            pop ecx
            mov EasternStar, TRUE
          .ENDIF
          ;----------------------------------------------;
          ;--- REPLACEMENT OF OLD ADDRESS ---;
          .IF DisplaysTrolling ; DisplaysTrolling=Displays Trolling or Drive type displayed???
            push dword ptr [ebx + 12]
            pop dword ptr [ebx + 20]
            push dword ptr [ebx + 16]
            pop dword ptr [ebx + 24]
          .ENDIF
          ;----------------------------------------;
          ;--- CALCULATION OF NEW ADDRESS ---;
          mov eax, Speed     ; Speed = Speed
          sub dword ptr [ebx + 8], eax
          mov eax, dword ptr [ebx]
          shl eax, 8
          cdq
          idiv dword ptr [ebx + 8]
          add eax, Xwindowdiv2
          mov dword ptr [ebx + 12], eax
          mov eax, dword ptr [ebx + 4]
          shl eax, 8
          cdq
          idiv dword ptr [ebx + 8]
          add eax, Ywindowdiv2
          mov dword ptr [ebx + 16], eax
          ;---------------------------;
          ;--- CORRECTION OF BUGS ---;
          .IF DisplaysTrolling && EasternStar ;Eastern Star Nv
            push dword ptr [ebx + 12]
            pop dword ptr [ebx + 20]
            push dword ptr [ebx + 16]
            pop dword ptr [ebx + 24]
            mov EasternStar, FALSE
          .ENDIF
          ;--------------------------------------------------------------------;
          ;--- CHECK IF THE STAR IS ALWAYS IN THE LIMITS OF THE SCREEN ---;
          mov eax, Xwindow
          mov edx, Ywindow    ;fenetre=window
          .IF dword ptr [ebx + 12] < 0 || dword ptr [ebx + 12] > eax || dword ptr [ebx + 16] < 0 || dword ptr [ebx + 16] > edx
            mov dword ptr [ebx + 8], 0
          .ENDIF
          push ecx
          ;---------------------------;
          ;--- COLOR OF THE STAR ---;
          xor eax, eax
          mov ah, cl
          mov al, ah
          shl eax, 8
          mov al, ah
          invoke CreatePen, PS_SOLID, NULL, eax
          push eax
          invoke SelectObject, hMemDC, eax
          ;--------------------------;
          ;--- DRAWING FROM THE STAR ---;
          push NULL
          .IF DisplaysTrolling
            push dword ptr [ebx + 24]
            push dword ptr [ebx + 20]
          .ELSE
            mov eax, dword ptr [ebx + 16]
            inc eax
            push eax
            push dword ptr [ebx + 12]
          .ENDIF
          push hMemDC
          call MoveToEx
          invoke LineTo, hMemDC, dword ptr [ebx + 12], dword ptr [ebx + 16]
          pop eax
          invoke DeleteObject, eax
          pop ecx
          inc ecx
        .ENDW
   invoke BitBlt, hdc, 0, 0, Xwindow, Ywindow, hMemDC, 0, 0, SRCCOPY
      ;  invoke DeleteObject, hBmp
      ;  invoke DeleteDC, hMemDC
       ; invoke EndPaint, hWnd, ADDR ps
		invoke InvalidateRect,hWnd,NULL,FALSE  
		
		.elseif wParam == IDT_TEXT
			;/* invalidate outdated rect */
			invoke InvalidateRect,hWnd,ADDR rScroll,FALSE
			
			add rScroll.top,GETV(ScrollOffset)
			add rScroll.bottom,eax			
			.if SDWORD PTR rScroll.top >= GETV(rClientWindow.bottom)
				mov ScrollOffset,-1	
			.else
				.if SDWORD PTR rScroll.bottom <= GETV(rClientWindow.top)
				mov ScrollOffset,1		
				.endif	
			.endif	
			; clear LayerDC with currently selected brush (= black =tansparent color)
			invoke BitBlt,hLayerDC1,0,0,rect.right,rect.bottom,hLayerDC1,0,0,PATCOPY
			
			;/* using plus for flags is an really bad idea ;-) */
			invoke DrawText,hLayerDC1,ADDR szWindowMsg,-1,ADDR rScroll,DT_CENTER or DT_TOP or DT_NOPREFIX or DT_NOCLIP
			
			;/* invalidate current rect */
			invoke InvalidateRect,hWnd,ADDR rScroll,FALSE
		.endif
      	
         mov eax,1
         ret
      .ELSEIF uMsg == WM_PAINT

	mov hdc,rv(BeginPaint,hWnd,ADDR ps)
	        ;/* copy only what needed !!! */
		mov esi,ps.rcPaint.right
		mov edi,ps.rcPaint.bottom
		sub esi,ps.rcPaint.left
		sub edi,ps.rcPaint.top
       
		
		;/* merge layer 1 & 2 */
			;/* copy stars to main-buffer */
			invoke BitBlt,hmainDC,ps.rcPaint.left,ps.rcPaint.top,esi,edi,hLayerDC2,ps.rcPaint.left,ps.rcPaint.top,SRCCOPY
	  		
	  		;/* copy text over - black = transparent */
	  		invoke TransparentBlt,hmainDC,ps.rcPaint.left,ps.rcPaint.top,esi,edi,hLayerDC1,ps.rcPaint.left,ps.rcPaint.top,esi,edi,0
		
		;/* copy main-buffer to screen -> no flickering */
		invoke BitBlt,hdc,ps.rcPaint.left,ps.rcPaint.top,esi,edi,hmainDC,ps.rcPaint.left,ps.rcPaint.top,SRCCOPY
        
        ;invoke DeleteObject, hBmp
        ;invoke DeleteDC, hMemDC
        invoke EndPaint, hWnd, ADDR ps
        	.ELSEIF  uMsg == WM_ERASEBKGND
		mov eax,1
		ret	
      .ELSE
        invoke DefWindowProc, hWnd, uMsg, wParam, lParam
        ret
      .ENDIF
      xor eax, eax
      ret
WndProc endp
NewStar PROC uses ebx pStar:DWORD
mov ebx, pStar
invoke Random, Xwindow
sub eax, Xwindowdiv2
mov dword ptr [ebx], eax
invoke Random, Ywindow
sub eax, Ywindowdiv2
mov dword ptr [ebx + 4], eax
mov dword ptr [ebx + 8], 256
push Xwindowdiv2
pop dword ptr [ebx + 12]
push Ywindowdiv2
pop dword ptr [ebx + 16]
mov eax, pStar
ret
NewStar ENDP 

Random PROC Limit:DWORD
mov eax, RandomNamePr
mov ecx, 23
mul ecx
add eax, 7
and eax, 0FFFFFFFFh
ror eax, 1
xor eax, RandomNamePr
mov RandomNamePr, eax
mov ecx, Limit 
xor edx, edx
div ecx
mov eax, edx
ret
Random ENDP
end start
